/*
 * @(#)AListStrings.java  9 February 2003
 *
 *   Viera Proulx      vkp@ccs.neu.edu
 */

/*
 * Abstract class that defines the behavior of a list of objects
 */
import java.awt.*;
import java.awt.geom.*;

public abstract class AListStrings{
    
     
    /*--------------------------------------------------------
     MapStringToString: 
     consume (String1 -> String2) (list of String1)
     produce (list of String2)
    --------------------------------------------------------*/
    abstract AListStrings mapStringToString(IString2String s2s);
     
    /*--------------------------------------------------------
     MapStringToBoolean: 
     consume (String1 -> boolean) (list of String1)
     produce (list of boolean)
    --------------------------------------------------------*/
    abstract AListBool mapStringToBool(IString2Bool s2b);
     
    /*--------------------------------------------------------
     OrMap: (String -> boolean) (list of String) -> boolean
    --------------------------------------------------------*/
    abstract boolean orMapString(IString2Bool o2b);
     
    /*--------------------------------------------------------
     Count the number of items in this list
     -------------------------------------------------------*/
    abstract int count();   
         
}
    
