/*
 * @(#)EmptyStrings.java  9 February 2003
 */

/*
 * Class that defines the behavior of an empty list of Strings
 */

public class EmptyStrings extends AListStrings{
    

    /*--------------------------------------------------------
     MapStringToString: 
     consume (String1 -> String2) (list of String1)
     produce (list of String2)
    --------------------------------------------------------*/
    AListStrings mapStringToString(IString2String s2s){
        return this;
    }
     
    /*--------------------------------------------------------
     MapStringToBoolean: 
     consume (String1 -> boolean) (list of String1)
     produce (list of boolean)
    --------------------------------------------------------*/
    AListBool mapStringToBool(IString2Bool s2b){
        return new EmptyBool();
    }
     
    /*--------------------------------------------------------
     OrMap: (String -> boolean) (list of String) -> boolean
    --------------------------------------------------------*/
    boolean orMapString(IString2Bool s2b){
        return false;
    }

    /*--------------------------------------------------------
     Count the number of items in this list
     -------------------------------------------------------*/
    int count(){
        return 0;
    }   
                                                     
    /*--------------------------------------------------------
     Print the contents of this list
     -------------------------------------------------------*/
    public String toString(){
        return "*";
    }
}
    
